use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum SearchAssetsQuery {
    SearchText(String),
    /// An case-insensitive substring match of the title or description of the asset.
    ExactSubstring(String),
    #[deprecated(note = "use labels instead")]
    Label(String),
    Labels(super::super::super::rids::api::LabelsFilter),
    #[deprecated(note = "use properties")]
    Property(super::super::super::super::api::Property),
    /// Matches assets that have a property with this key, regardless of value.
    PropertyKey(String),
    Properties(super::super::super::rids::api::PropertiesFilter),
    #[deprecated(note = "use assetTypes")]
    TypeRid(super::super::super::rids::api::TypeRid),
    AssetTypes(super::AssetTypesFilter),
    #[deprecated(note = "staged assets are no longer returned in the search endpoint")]
    IsStaged(bool),
    Archived(bool),
    And(Vec<super::SearchAssetsQuery>),
    Or(Vec<super::SearchAssetsQuery>),
    Not(Box<super::SearchAssetsQuery>),
    Workspace(conjure_object::ResourceIdentifier),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for SearchAssetsQuery {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            SearchAssetsQuery::SearchText(value) => {
                map.serialize_entry(&"type", &"searchText")?;
                map.serialize_entry(&"searchText", value)?;
            }
            SearchAssetsQuery::ExactSubstring(value) => {
                map.serialize_entry(&"type", &"exactSubstring")?;
                map.serialize_entry(&"exactSubstring", value)?;
            }
            #[allow(deprecated)]
            SearchAssetsQuery::Label(value) => {
                map.serialize_entry(&"type", &"label")?;
                map.serialize_entry(&"label", value)?;
            }
            SearchAssetsQuery::Labels(value) => {
                map.serialize_entry(&"type", &"labels")?;
                map.serialize_entry(&"labels", value)?;
            }
            #[allow(deprecated)]
            SearchAssetsQuery::Property(value) => {
                map.serialize_entry(&"type", &"property")?;
                map.serialize_entry(&"property", value)?;
            }
            SearchAssetsQuery::PropertyKey(value) => {
                map.serialize_entry(&"type", &"propertyKey")?;
                map.serialize_entry(&"propertyKey", value)?;
            }
            SearchAssetsQuery::Properties(value) => {
                map.serialize_entry(&"type", &"properties")?;
                map.serialize_entry(&"properties", value)?;
            }
            #[allow(deprecated)]
            SearchAssetsQuery::TypeRid(value) => {
                map.serialize_entry(&"type", &"typeRid")?;
                map.serialize_entry(&"typeRid", value)?;
            }
            SearchAssetsQuery::AssetTypes(value) => {
                map.serialize_entry(&"type", &"assetTypes")?;
                map.serialize_entry(&"assetTypes", value)?;
            }
            #[allow(deprecated)]
            SearchAssetsQuery::IsStaged(value) => {
                map.serialize_entry(&"type", &"isStaged")?;
                map.serialize_entry(&"isStaged", value)?;
            }
            SearchAssetsQuery::Archived(value) => {
                map.serialize_entry(&"type", &"archived")?;
                map.serialize_entry(&"archived", value)?;
            }
            SearchAssetsQuery::And(value) => {
                map.serialize_entry(&"type", &"and")?;
                map.serialize_entry(&"and", value)?;
            }
            SearchAssetsQuery::Or(value) => {
                map.serialize_entry(&"type", &"or")?;
                map.serialize_entry(&"or", value)?;
            }
            SearchAssetsQuery::Not(value) => {
                map.serialize_entry(&"type", &"not")?;
                map.serialize_entry(&"not", value)?;
            }
            SearchAssetsQuery::Workspace(value) => {
                map.serialize_entry(&"type", &"workspace")?;
                map.serialize_entry(&"workspace", value)?;
            }
            SearchAssetsQuery::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for SearchAssetsQuery {
    fn deserialize<D>(d: D) -> Result<SearchAssetsQuery, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = SearchAssetsQuery;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union SearchAssetsQuery")
    }
    fn visit_map<A>(self, mut map: A) -> Result<SearchAssetsQuery, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::SearchText, Some(Variant_::SearchText)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::SearchText(value)
                    }
                    (Variant_::ExactSubstring, Some(Variant_::ExactSubstring)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::ExactSubstring(value)
                    }
                    #[allow(deprecated)]
                    (Variant_::Label, Some(Variant_::Label)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Label(value)
                    }
                    (Variant_::Labels, Some(Variant_::Labels)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Labels(value)
                    }
                    #[allow(deprecated)]
                    (Variant_::Property, Some(Variant_::Property)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Property(value)
                    }
                    (Variant_::PropertyKey, Some(Variant_::PropertyKey)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::PropertyKey(value)
                    }
                    (Variant_::Properties, Some(Variant_::Properties)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Properties(value)
                    }
                    #[allow(deprecated)]
                    (Variant_::TypeRid, Some(Variant_::TypeRid)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::TypeRid(value)
                    }
                    (Variant_::AssetTypes, Some(Variant_::AssetTypes)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::AssetTypes(value)
                    }
                    #[allow(deprecated)]
                    (Variant_::IsStaged, Some(Variant_::IsStaged)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::IsStaged(value)
                    }
                    (Variant_::Archived, Some(Variant_::Archived)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Archived(value)
                    }
                    (Variant_::And, Some(Variant_::And)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::And(value)
                    }
                    (Variant_::Or, Some(Variant_::Or)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Or(value)
                    }
                    (Variant_::Not, Some(Variant_::Not)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Not(value)
                    }
                    (Variant_::Workspace, Some(Variant_::Workspace)) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Workspace(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            SearchAssetsQuery::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::SearchText => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::SearchText(value)
                    }
                    Variant_::ExactSubstring => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::ExactSubstring(value)
                    }
                    Variant_::Label => {
                        let value = map.next_value()?;
                        #[allow(deprecated)] SearchAssetsQuery::Label(value)
                    }
                    Variant_::Labels => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Labels(value)
                    }
                    Variant_::Property => {
                        let value = map.next_value()?;
                        #[allow(deprecated)] SearchAssetsQuery::Property(value)
                    }
                    Variant_::PropertyKey => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::PropertyKey(value)
                    }
                    Variant_::Properties => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Properties(value)
                    }
                    Variant_::TypeRid => {
                        let value = map.next_value()?;
                        #[allow(deprecated)] SearchAssetsQuery::TypeRid(value)
                    }
                    Variant_::AssetTypes => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::AssetTypes(value)
                    }
                    Variant_::IsStaged => {
                        let value = map.next_value()?;
                        #[allow(deprecated)] SearchAssetsQuery::IsStaged(value)
                    }
                    Variant_::Archived => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Archived(value)
                    }
                    Variant_::And => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::And(value)
                    }
                    Variant_::Or => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Or(value)
                    }
                    Variant_::Not => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Not(value)
                    }
                    Variant_::Workspace => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Workspace(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        SearchAssetsQuery::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    SearchText,
    ExactSubstring,
    Label,
    Labels,
    Property,
    PropertyKey,
    Properties,
    TypeRid,
    AssetTypes,
    IsStaged,
    Archived,
    And,
    Or,
    Not,
    Workspace,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::SearchText => "searchText",
            Variant_::ExactSubstring => "exactSubstring",
            Variant_::Label => "label",
            Variant_::Labels => "labels",
            Variant_::Property => "property",
            Variant_::PropertyKey => "propertyKey",
            Variant_::Properties => "properties",
            Variant_::TypeRid => "typeRid",
            Variant_::AssetTypes => "assetTypes",
            Variant_::IsStaged => "isStaged",
            Variant_::Archived => "archived",
            Variant_::And => "and",
            Variant_::Or => "or",
            Variant_::Not => "not",
            Variant_::Workspace => "workspace",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "searchText" => Variant_::SearchText,
            "exactSubstring" => Variant_::ExactSubstring,
            "label" => Variant_::Label,
            "labels" => Variant_::Labels,
            "property" => Variant_::Property,
            "propertyKey" => Variant_::PropertyKey,
            "properties" => Variant_::Properties,
            "typeRid" => Variant_::TypeRid,
            "assetTypes" => Variant_::AssetTypes,
            "isStaged" => Variant_::IsStaged,
            "archived" => Variant_::Archived,
            "and" => Variant_::And,
            "or" => Variant_::Or,
            "not" => Variant_::Not,
            "workspace" => Variant_::Workspace,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the SearchAssetsQuery union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
